/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var calder = function (T) {
        var JI = new Continuation();
        var fail = function () { JI(function () {
            return false;
        });};
        var visit = function (i) {
            var JI = new Continuation();
            var n;
            var n1;
            var n2;
            return function () {
                n = T[i];
                if (n == -1) return 0;
                i = i * 2;
                n1 = visit(i + 1)();
                n2 = visit(i + 2)();
                if (n1 == n2) return n + n1 + n2;
                fail();
            };
        };
        return function () {
            visit(0)();
            return true;
        };
    };
    return function () {
        print(calder([2, 5, 1, 2, 2, 4, 4,
                      -1, -1, -1, -1, -1, -1, -1, -1])());
    };
};
main()();
