(*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 *)

#use "gen.ml";;

(* Looping program to check proper elimination of continuation stacks *)

let loop
= let i = Var "i" in
  let l = Lbl "loop" in
  program
  [ defVar i
  ; defLbl l
    [ cmdAssign (expVar i) (expSub (expVar i) (expInt 1))
    ; cmdIfThen (expGt (expVar i) (expInt 0))
                (cmdGoto l)
    (* ; cmdPrint (expVar i) *) ] ]
  [ cmdAssign (expVar i) (expInt 1000000)
  ; cmdGoto l ]

let () = print_string (unPrg loop)
