(*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 *)

#use "gen.ml";;

(*

  Pairs and triples are a two and three element arrays, respectivly.

  Note: in the translation arrays are constructed without dimensions,
  should we add this? 
  (Of course JS does not care and will dynamically resize the array
  depending on the indexes we write to).

procedure printpairs (n, xs)
  if n = 0 then return;
  printpairs(n-1, xs)
  print(...)
end

procedure printtriples (n, xs)
  if n = 0 then return;
  printtriples(n-1, xs)
  print(...)
end

procedure PTT (n, ps)
    integer i, j, x;
    array ts;

exhausted:
    PTT := ts;

    procedure next
      integer k, l;
      k := l := 0;
    loopP:
      x := ps[k][l];
      yield from l1 to l2;
      l := l + 1;
      if l > 1 then block l := 0; k := k + 1; end;
      goto loopP;
    end

    i := j := 0;
    ts := array[n];
    ts[i] := array[3];
loopT:
    if n = 0 then goto exhausted;
l1: next;
l2: ts[i][j] := x;
    n := n - 1;
    j := j + 1;
    if j > 2 then block
      j := 0;
      i := i + 1;
      ts[i] := array[3];
    end;
    goto loopT;

*)

let ptt
= let ptt = Var "PTT" in
  let ps = Var "ps" in
  let ps_ v = expIndex (expVar ps) v in
  let ps__ v1 v2 = expIndex (ps_ v1) v2 in
  let n = Var "n" in
  let i = Var "i" in
  let j = Var "j" in
  let k = Var "k" in
  let l = Var "l" in
  let x = Var "x" in
  let ts = Var "ts" in
  let ts_ v = expIndex (expVar ts) v in
  let ts__ v1 v2 = expIndex (ts_ v1) v2 in
  let m = Var "m" in
  let pp = Var "pp" in
  let pt = Var "pt" in
  let next = Var "next" in
  let exhausted = Lbl "exhausted" in
  let loopP = Lbl "loopP" in
  let loopT = Lbl "loopT" in
  let l1 = Lbl "l1" in
  let l2 = Lbl "l2" in
    program
      [ defVar ps; defVar ts
      ; defFun pp [m; ps] []
	  [ cmdIfThen (expEq (expVar m) (expInt 0))
	      (cmdReturn expBottom)
	  ; cmdExp (expCall pp [expSub (expVar m) (expInt 1); expVar ps])
	  ; cmdPrint (expStrConcat
			(expStr "(")
			(expStrConcat
			   (ps__ (expSub (expVar m) (expInt 1)) (expInt 0))
			   (expStrConcat
			      (expStr ", ")
			      (expStrConcat
				 (ps__ (expSub (expVar m) (expInt 1)) (expInt 1))
				 (expStr ")")))))
			   
	  ]
      ; defFun pt [m; ts] []
	  [ cmdIfThen (expEq (expVar m) (expInt 0))
	      (cmdReturn expBottom)
	  ; cmdExp (expCall pt [expSub (expVar m) (expInt 1); expVar ts])
	  ; cmdPrint (expStrConcat
			(expStr "(")
			(expStrConcat
			   (ts__ (expSub (expVar m) (expInt 1)) (expInt 0))
			   (expStrConcat
			      (expStr ", ")
			      (expStrConcat
				 (ts__ (expSub (expVar m) (expInt 1)) (expInt 1))
				 (expStrConcat
				    (expStr ", ")
				    (expStrConcat
				       (ts__ (expSub (expVar m) (expInt 1)) (expInt 2))
				       (expStr ")")))))))
			   
	  ]
      ; defFun ptt [n; ps]
	  [ defVar i; defVar j; defVar x; defVar ts
	  ; defFun next []
	    [ defVar k; defVar l
	    ; defLbl loopP 
	      [ cmdAssign (expVar x) (ps__ (expVar k) (expVar l))
	      ; cmdYield l1 l2
	      ; cmdAssign (expVar l) (expAdd (expVar l) (expInt 1))
	      ; cmdIfThen (expGt (expVar l) (expInt 1))
		(cmdBlock []
		   [ cmdAssign (expVar l) (expInt 0)
		   ; cmdAssign (expVar k) (expAdd (expVar k) (expInt 1))
		   ])
	      ; cmdGoto loopP
	      ]
	    ]
	    [ cmdAssign (expVar k) (expInt 0)
	    ; cmdAssign (expVar l) (expInt 0)
	    ; cmdGoto loopP
	    ]
	  ; defLbl exhausted
	    [ cmdReturn (expVar ts)
	    ]
	  ; defLbl loopT
	    [ cmdIfThen (expEq (expVar n) (expInt 0))
		(cmdGoto exhausted)
	    ; cmdGoto l1
	    ]
	  ; defLbl l1
	    [ cmdExp (expCall next [])
	    ; cmdGoto l2
	    ]
	  ; defLbl l2
	    [ cmdAssign (ts__ (expVar i) (expVar j)) (expVar x)
	    ; cmdAssign (expVar n) (expSub (expVar n) (expInt 1))
	    ; cmdAssign (expVar j) (expAdd (expVar j) (expInt 1))
	    ; cmdIfThen (expGt (expVar j) (expInt 2))
	      (cmdBlock []
		 [ cmdAssign (expVar j) (expInt 0)
		 ; cmdAssign (expVar i) (expAdd (expVar i) (expInt 1))
		 ; cmdAssign (ts_ (expVar i)) (expArray [])
		 ])
	    ; cmdGoto loopT
	    ]
	  ]
	  [ cmdAssign (expVar i) (expInt 0)
	  ; cmdAssign (expVar j) (expInt 0)
	  ; cmdAssign (expVar ts) (expArray [])
	  ; cmdAssign (ts_ (expVar i)) (expArray [])
	  ; cmdGoto loopT
	  ]
      ]
      [ cmdAssign (expVar ps) (expArray [ expArray [expInt 1; expInt 2]
					; expArray [expInt 3; expInt 4]
					; expArray [expInt 5; expInt 6] ])
      ; cmdExp (expCall pp [expInt 3; expVar ps])
      ; cmdAssign (expVar ts) (expCall ptt [expInt 6; expVar ps])
      ; cmdExp (expCall pt [expInt 2; expVar ts])
      ]

let () = print_string (unPrg ptt)

