/*                         J is for JavaScript:
 *                    A direct-style correspondence
 *             between Algol-like languages and JavaScript
 *                   using first-class continuations
 *
 *            Olivier Danvy, Chung-chieh Shan, and Ian Zerny
 *                            Copyright 2009
 *                  GPLv3, see LICENSE.txt for details
 *
 *                    www.zerny.dk/j-is-for-js.html
 *
 *                         Version: April 2011
 */

var main = function () {
    var JI = new Continuation();
    var t1;
    var t2;
    var traverse = function (t, f) {
        var JI = new Continuation();
        var visit = function (i) {
            var JI = new Continuation();
            var n;
            return function () {
                n = t[i];
                if (n != -1) return f(n)();
                i = 2 * i;
                visit(i + 1)();
                visit(i + 2)();
            };
        };
        return function () {
            visit(0)();
        };
    };
    var samefringe = function (t1, t2) {
        var JI = new Continuation();
        var v1;
        var v2;
        var next1 = function (e) {
            var JI = new Continuation();
            return function () {
                v1 = e;
                (function () { l1 = new Continuation(); l2(); })();
            };
        };
        var next2 = function (e) {
            var JI = new Continuation();
            return function () {
                v2 = e;
                (function () { l2 = new Continuation(); compare(); })();
            };
        };
        var l1 = function () { JI(function () {
            traverse(t1, next1)();
            next1(undefined)();
        });};
        var l2 = function () { JI(function () {
            traverse(t2, next2)();
            next2(undefined)();
        });};
        var compare = function () { JI(function () {
            if (v1 != v2) return false;
            if (v1 == undefined) return true;
            l1();
        });};
        return function () {
            l1();
        };
    };
    return function () {
        t1 = [-1, 1,
              -1, undefined, undefined, 2, 3];
        t2 = [-1,
              -1, 3, 1, 2, undefined, undefined];
        print(samefringe(t1, t2)());
    };
};
main()();
